美文网首页
CUC-SUMMER-CONTEST-1-G

CUC-SUMMER-CONTEST-1-G

作者: Nioge | 来源:发表于2017-08-08 19:50 被阅读0次
    G - Lorry
    CodeForces - 3B

    A group of tourists is going to kayak and catamaran tour. A rented lorry has arrived to the boat depot to take kayaks and catamarans to the point of departure. It's known that all kayaks are of the same size (and each of them occupies the space of 1 cubic metre), and all catamarans are of the same size, but two times bigger than kayaks (and occupy the space of 2 cubic metres).

    Each waterborne vehicle has a particular carrying capacity, and it should be noted that waterborne vehicles that look the same can have different carrying capacities. Knowing the truck body volume and the list of waterborne vehicles in the boat depot (for each one its type and carrying capacity are known), find out such set of vehicles that can be taken in the lorry, and that has the maximum total carrying capacity. The truck body volume of the lorry can be used effectively, that is to say you can always put into the lorry a waterborne vehicle that occupies the space not exceeding the free space left in the truck body.

    Input
    The first line contains a pair of integer numbers n and v (1 ≤ n ≤ 105; 1 ≤ v ≤ 109), where n is the number of waterborne vehicles in the boat depot, and v is the truck body volume of the lorry in cubic metres. The following n lines contain the information about the waterborne vehicles, that is a pair of numbers ti, pi (1 ≤ ti ≤ 2; 1 ≤ pi ≤ 104), where ti is the vehicle type (1 – a kayak, 2 – a catamaran), and pi is its carrying capacity. The waterborne vehicles are enumerated in order of their appearance in the input file.

    Output
    In the first line print the maximum possible carrying capacity of the set. In the second line print a string consisting of the numbers of the vehicles that make the optimal set. If the answer is not unique, print any of them.

    Example
    Input
    3 2
    1 2
    2 7
    1 3
    Output
    7
    2


    题意:有体积为1和2的两种船,每条船载重都不同,求一个卡车装哪些船使总载重量最大。

    解法:看上去是背包问题,但用背包问题的解法解不了,因为范围太大,开不出这么大的内存。因为只有1、2两种体积,所以可以用贪心来做。先对船以单位体积的载重量从大到小排序,并找到载重最小的一个1体积的船放到序列最后,然后按序列依次选择船,直到卡车剩2体积。此时判断序列剩下的1体积的船中最大的两个船的载重量与最大的2体积船的载重量比较,取较大值。

    代码:

    #include<iostream>
    #include<algorithm>
    #include<math.h>
    using namespace std;
    #define maxn 100005
    int q[maxn];
    int qq=0;
    struct node{
        int x;
        int vol;
        float c;
    };
    bool cmp(node a,node b){
        return a.c>b.c;
    }
    node p[maxn];
    int main()
    {
        int n,m,ans=0,minn=999999,minx=-1;
        cin>>n>>m;
        for(int i=0;i<n;i++){
            int u,v;
            cin>>u>>v;
            p[i].x=i+1;
            p[i].vol=u;
            p[i].c=v*1.0/u;
            if(u==1)
                if(minn>v){
                    minn=v;
                    minx=i;
                }
        }
        node temp;
        temp=p[minx];
        p[minx]=p[n-1];
        p[n-1]=temp;
        sort(p,p+n-1,cmp);
        for(int i=0;i<n;i++){
            if(m>2){
                ans+=p[i].vol*p[i].c;
                m-=p[i].vol;
                q[qq]=p[i].x;
                qq++;
                continue;
            }
            if(m==2){
                float s=0,d=0;
                int cnt=0,aa,bb,cc=0;
                for(int j=i;j<n;j++){
                    if(d!=0&&cnt==2)
                        break;
                    if(p[j].vol==1&&cnt==0){
                        s+=p[j].c;
                        cnt++;
                        aa=j;
                        continue;
                    }
                    if(p[j].vol==1&&cnt==1){
                        s+=p[j].c;
                        cnt++;
                        bb=j;
                    }
                    if(p[j].vol==2&&d==0){
                        d=p[j].c*2;
                        cc=j;
                    }
                }
                if(s==0&&d==0)
                    break;
                else if(s>d){
                    ans+=s;
                    if(cnt==1){
                        q[qq]=p[aa].x;
                        qq++;
                    }
                    if(cnt==2){
                        q[qq]=p[aa].x;
                        qq++;
                        q[qq]=p[bb].x;
                        qq++;
                    }
                }
                else{
                    ans+=d;
                    q[qq]=p[cc].x;
                    qq++;
                }
                break;
            }
            if(m==1){
                if(p[i].vol==1){
                    ans+=p[i].c;
                    q[qq]=p[i].x;
                    qq++;
                    break;
                }
            }
        }
        cout<<ans<<endl;
        for(int i=0;i<qq;i++){
            cout<<q[i];
            if(i!=qq-1)
                cout<<" ";
        }
        cout<<endl;
    }
    

    相关文章

      网友评论

          本文标题:CUC-SUMMER-CONTEST-1-G

          本文链接:https://www.haomeiwen.com/subject/sirxrxtx.html